Index: branches/2258_IslandALPS/IslandALPS/3.3/HeuristicLab.Algorithms.IslandALPS-3.3.csproj
===================================================================
--- branches/IslandALPS/IslandALPS/3.3/HeuristicLab.Algorithms.IslandALPS-3.3.csproj	(revision 13962)
+++ branches/2258_IslandALPS/IslandALPS/3.3/HeuristicLab.Algorithms.IslandALPS-3.3.csproj	(revision 15948)
@@ -18,5 +18,5 @@
     <DebugType>full</DebugType>
     <Optimize>false</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -26,5 +26,5 @@
     <DebugType>pdbonly</DebugType>
     <Optimize>true</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
Index: branches/2258_IslandALPS/IslandALPS/3.3/Plugin.cs
===================================================================
--- branches/IslandALPS/IslandALPS/3.3/Plugin.cs	(revision 13962)
+++ 	(revision )
@@ -1,20 +1,0 @@
-﻿using HeuristicLab.PluginInfrastructure;
-
-namespace HeuristicLab.Algorithms.IslandALPS {
-
-  [Plugin("HeuristicLab.Algorithms.IslandALPS", "Coarse grained version of ALPS.", "3.3.0.0")]
-  [PluginFile("HeuristicLab.Algorithms.IslandALPS-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Core", "3.3")]
-  [PluginDependency("HeuristicLab.Common", "3.3")]
-  [PluginDependency("HeuristicLab.Collections", "3.3")]
-  [PluginDependency("HeuristicLab.Data", "3.3")]
-  [PluginDependency("HeuristicLab.Operators", "3.3")]
-  [PluginDependency("HeuristicLab.Optimization", "3.3")]
-  [PluginDependency("HeuristicLab.Optimization.Operators", "3.3")]
-  [PluginDependency("HeuristicLab.Parameters", "3.3")]
-  [PluginDependency("HeuristicLab.Persistence", "3.3")]
-  [PluginDependency("HeuristicLab.Random", "3.3")]
-  [PluginDependency("HeuristicLab.Algorithms.ALPS", "3.3")]
-  public class HeuristicLabAlgorithmsIslandALPSPlugin : PluginBase {
-  }
-}
Index: branches/2258_IslandALPS/IslandALPS/3.3/Plugin.cs.frame
===================================================================
--- branches/2258_IslandALPS/IslandALPS/3.3/Plugin.cs.frame	(revision 15948)
+++ branches/2258_IslandALPS/IslandALPS/3.3/Plugin.cs.frame	(revision 15948)
@@ -0,0 +1,21 @@
+﻿using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Algorithms.IslandALPS {
+  [Plugin("HeuristicLab.Algorithms.IslandALPS", "Coarse grained version of ALPS.", "3.3.0.$WCREV$")]
+  [PluginFile("HeuristicLab.Algorithms.IslandALPS-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Algorithms.ALPS", "3.3")]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Random", "3.3")]
+  [PluginDependency("HeuristicLab.Selection", "3.3")]
+  public class HeuristicLabAlgorithmsIslandALPSPlugin : PluginBase {
+  }
+}
Index: branches/2258_IslandALPS/IslandALPS/3.3/Properties/AssemblyInfo.cs
===================================================================
--- branches/IslandALPS/IslandALPS/3.3/Properties/AssemblyInfo.cs	(revision 13962)
+++ 	(revision )
@@ -1,36 +1,0 @@
-﻿using System.Reflection;
-using System.Runtime.CompilerServices;
-using System.Runtime.InteropServices;
-
-// General Information about an assembly is controlled through the following 
-// set of attributes. Change these attribute values to modify the information
-// associated with an assembly.
-[assembly: AssemblyTitle("IslandALPS")]
-[assembly: AssemblyDescription("")]
-[assembly: AssemblyConfiguration("")]
-[assembly: AssemblyCompany("HEAL")]
-[assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("")]
-[assembly: AssemblyTrademark("")]
-[assembly: AssemblyCulture("")]
-
-// Setting ComVisible to false makes the types in this assembly not visible 
-// to COM components.  If you need to access a type in this assembly from 
-// COM, set the ComVisible attribute to true on that type.
-[assembly: ComVisible(false)]
-
-// The following GUID is for the ID of the typelib if this project is exposed to COM
-[assembly: Guid("6773cd7d-de39-4003-a2f9-fd3752abff8d")]
-
-// Version information for an assembly consists of the following four values:
-//
-//      Major Version
-//      Minor Version 
-//      Build Number
-//      Revision
-//
-// You can specify all the values or you can default the Build and Revision Numbers 
-// by using the '*' as shown below:
-// [assembly: AssemblyVersion("1.0.*")]
-[assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.0.0")]
Index: branches/2258_IslandALPS/IslandALPS/3.3/plugin.cs.frame
===================================================================
--- branches/IslandALPS/IslandALPS/3.3/plugin.cs.frame	(revision 13962)
+++ 	(revision )
@@ -1,21 +1,0 @@
-﻿using HeuristicLab.PluginInfrastructure;
-
-namespace HeuristicLab.Algorithms.IslandALPS {
-  [Plugin("HeuristicLab.Algorithms.IslandALPS", "Coarse grained version of ALPS.", "3.3.0.$WCREV$")]
-  [PluginFile("HeuristicLab.Algorithms.IslandALPS-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Algorithms.ALPS", "3.3")]
-  [PluginDependency("HeuristicLab.Analysis", "3.3")]
-  [PluginDependency("HeuristicLab.Collections", "3.3")]
-  [PluginDependency("HeuristicLab.Common", "3.3")]
-  [PluginDependency("HeuristicLab.Core", "3.3")]
-  [PluginDependency("HeuristicLab.Data", "3.3")]
-  [PluginDependency("HeuristicLab.Operators", "3.3")]
-  [PluginDependency("HeuristicLab.Optimization", "3.3")]
-  [PluginDependency("HeuristicLab.Optimization.Operators", "3.3")]
-  [PluginDependency("HeuristicLab.Parameters", "3.3")]
-  [PluginDependency("HeuristicLab.Persistence", "3.3")]
-  [PluginDependency("HeuristicLab.Random", "3.3")]
-  [PluginDependency("HeuristicLab.Selection", "3.3")]
-  public class HeuristicLabAlgorithmsIslandALPSPlugin : PluginBase {
-  }
-}